/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumElementnote;
import de.ship.db.tables.records.VCoreElementnoteDeDeRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreElementnoteDeDe extends TableImpl<VCoreElementnoteDeDeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_elementnote_de_de</code>
     */
    public static final VCoreElementnoteDeDe V_CORE_ELEMENTNOTE_DE_DE = new VCoreElementnoteDeDe();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreElementnoteDeDeRecord> getRecordType() {
        return VCoreElementnoteDeDeRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_elementnote_de_de.lastchange</code>.
     */
    public final TableField<VCoreElementnoteDeDeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_core_elementnote_de_de.pk</code>.
     */
    public final TableField<VCoreElementnoteDeDeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_elementnote_de_de.fk_element</code>.
     */
    public final TableField<VCoreElementnoteDeDeRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_elementnote_de_de.note_type</code>.
     */
    public final TableField<VCoreElementnoteDeDeRecord, EnumElementnote> NOTE_TYPE = createField(DSL.name("note_type"), SQLDataType.VARCHAR.asEnumDataType(EnumElementnote.class), this, "");

    /**
     * The column <code>common_dd.v_core_elementnote_de_de.fk_note_lang</code>.
     */
    public final TableField<VCoreElementnoteDeDeRecord, String> FK_NOTE_LANG = createField(DSL.name("fk_note_lang"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_elementnote_de_de.de_de</code>.
     */
    public final TableField<VCoreElementnoteDeDeRecord, String> DE_DE = createField(DSL.name("de_de"), SQLDataType.CLOB, this, "");

    private VCoreElementnoteDeDe(Name alias, Table<VCoreElementnoteDeDeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreElementnoteDeDe(Name alias, Table<VCoreElementnoteDeDeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_elementnote_de_de" as  SELECT t_core_elementnote.lastchange,
         t_core_elementnote.pk,
         t_core_elementnote.fk_element,
         t_core_elementnote.note_type,
         t_core_elementnote.fk_note_lang,
         t_core_translation.value AS de_de
        FROM (common_dd.t_core_elementnote
          LEFT JOIN common_dd.t_core_translation ON (((t_core_translation.fk_trans_key = t_core_elementnote.fk_note_lang) AND (t_core_translation.isocode = 'de_DE'::common_dd.enum_isocode) AND (t_core_translation.category = 'crf'::common_dd.enum_trans_category))));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_elementnote_de_de</code> table
     * reference
     */
    public VCoreElementnoteDeDe(String alias) {
        this(DSL.name(alias), V_CORE_ELEMENTNOTE_DE_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_elementnote_de_de</code> table
     * reference
     */
    public VCoreElementnoteDeDe(Name alias) {
        this(alias, V_CORE_ELEMENTNOTE_DE_DE);
    }

    /**
     * Create a <code>common_dd.v_core_elementnote_de_de</code> table reference
     */
    public VCoreElementnoteDeDe() {
        this(DSL.name("v_core_elementnote_de_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreElementnoteDeDe as(String alias) {
        return new VCoreElementnoteDeDe(DSL.name(alias), this);
    }

    @Override
    public VCoreElementnoteDeDe as(Name alias) {
        return new VCoreElementnoteDeDe(alias, this);
    }

    @Override
    public VCoreElementnoteDeDe as(Table<?> alias) {
        return new VCoreElementnoteDeDe(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementnoteDeDe rename(String name) {
        return new VCoreElementnoteDeDe(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementnoteDeDe rename(Name name) {
        return new VCoreElementnoteDeDe(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreElementnoteDeDe rename(Table<?> name) {
        return new VCoreElementnoteDeDe(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementnoteDeDe where(Condition condition) {
        return new VCoreElementnoteDeDe(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementnoteDeDe where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementnoteDeDe where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementnoteDeDe where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementnoteDeDe where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementnoteDeDe where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementnoteDeDe where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreElementnoteDeDe where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementnoteDeDe whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreElementnoteDeDe whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
